## Component for Example 5
## 55x^2 + 315xy + 451y^2 = -3971
## "Matthews’ Method for Solving ax^2 + bxy + cy^2 = N"
## by 'J.P.Robertson'. Page 8.
## and 11x^2 + 23xy - 20y^2 = 14, 3x^2 + xy+ 4y^2 = 8
## supplementary examples.
## This code is to show the Euclid GCD role in Transforms.
## The Unimodular Transform being [1,-1],[1,0],supplementary example [1,1],[-1,0]
## Note The Chinese Remainder for If gcd(a,qi) = 1, then take xi = 1, yi = 0.
## For the below implied switch, If gcd(a,qi) != 1 gives, um_C below for um_A
## Ie J.P Robertson. Page 3. A = aα^2 + bαγ + cγ^2,## Requires More Testing Data. ##
## Then 1st Modulo Expondentia Z^n will be via M1,M2,M3. Quadratic Forms, Bhagrava Cubes.
## Initial indications are that a lower Dimension discriminat can be found,
## for 1 of a Pair Multidimension. Ie Quartic and cubic rational root. For 2nd
## Modulo Expondentia Z^n. Looking to Ken Ono's congruences. 
##
##   

##Cut and Paste into Python Idle. Warren B

import math

def gcd_unimodular_Checker():
    Euclid_Num_Trans = 0
    Euclid_Num_x = 0
    Euclid_Num_y = 0
    Total_ABC = 0
    um_A = 0
    um_B = 0
    um_C = 0
    ax = int(input("Enter number 'a' in equation ax^2 + bxy + cy^2 = ? "))
    bx = int(input("Enter number 'b' in equation ax^2 + bxy + cy^2 = ? "))
    ay = int(input("Enter number 'c' in equation ax^2 + bxy + cy^2 = ? "))
    ToT_xy = int(input("Enter number ? in equation ax^2 + bxy + cy^2 = ? "))
    Euclid_Num_x = math.gcd(ax, ToT_xy)
    Euclid_Num_y = math.gcd(ay, ToT_xy)
    if((Euclid_Num_x) == 1):
        print("Ok ax^2, gcd == 1")
    if((Euclid_Num_y) == 1):
        print("Ok cy^2, gcd == 1")
    if((Euclid_Num_x > 1)and(Euclid_Num_y > 1)):
        print("ax^2 GCD is" ,Euclid_Num_x, "Transform Req, gcd > 1")
        print("cy^2 GCD is" ,Euclid_Num_y, "Unimodular Req, gcd > 1")
        print("Transform Matrix [1,-1],[1,0]")
        um_A = (ax *(1*1))+ (bx *(1)*(1)) + (ay *(1*1))
        um_B = ((2 * ax)*1*(-1))+(bx *1*0)+(bx *(-1)*1)+((2*ay)*1*0)
        um_C = (ax * (-1*-1)) + (bx * (-1) * 0) + (ay *(0*0))
        Total_ABC = um_A + um_B + um_C
        print(um_A,"X^2","+",um_B,"XY","+",um_C,"Y^2"," = ",Total_ABC)
        Euclid_Num_Trans = math.gcd(um_A, ToT_xy)
    if((Euclid_Num_x) == 1)and((Euclid_Num_y) != 1):
        print("ax^2 GCD is" ,Euclid_Num_x, "Ok, gcd = 1")
        print("cy^2 GCD is" ,Euclid_Num_y, "Transform Req, gcd > 1")
        print("Transform Matrix [1,1],[-1,0]")
        um_A = (ax *(1*1))+ (bx *(-1*0)) + (ay *(-1*-1))
        um_B = ((2 * ax)*(1*1))+(bx *(1*0))+(bx *(-1*1))+((2*ay)*(-1*0))
        um_C = (ax *(1*1)) + (bx *(1*0)) + (ay *(0*0))
        Total_ABC = um_A + um_B + um_C
        print(um_A,"X^2","+",um_B,"XY","+",um_C,"Y^2"," = ",Total_ABC)
        Euclid_Num_Trans = math.gcd(um_A, ToT_xy)
    if((Euclid_Num_Trans) == 1):
        print("Ok Unimodular Transform complete,(",um_A,",",ToT_xy,")gcd == 1")
    if((Euclid_Num_Trans) != 1):
        print("Transform Incomplete,(",um_A,",",ToT_xy,")gcd != 1")

       
       
## Results so far ## Note " (Gauss’s Reduction Algorithm).
## Every binary quadratic form of negative discriminant is
## properly equivalent to a reduced form with the same discriminant."
## Such as. c < a, imply [0,-1],[1,0]. and Imaginary quadratic ﬁelds
## Hence Preliminary Results
        
>>> gcd_unimodular_Checker()
Enter number 'a' in equation ax^2 + bxy + cy^2 = ? 3
Enter number 'b' in equation ax^2 + bxy + cy^2 = ? 1
Enter number 'c' in equation ax^2 + bxy + cy^2 = ? 4
Enter number ? in equation ax^2 + bxy + cy^2 = ? 8
Ok ax^2, gcd == 1
ax^2 GCD is 1 Ok, gcd = 1
cy^2 GCD is 4 Transform Req, gcd > 1, c < a
Transform Matrix [1,1],[-1,0]
7 X^2 + 5 XY + 3 Y^2  =  15
Ok Unimodular Transform complete,( 7 , 8 )gcd == 1
>>> gcd_unimodular_Checker()
Enter number 'a' in equation ax^2 + bxy + cy^2 = ? 11
Enter number 'b' in equation ax^2 + bxy + cy^2 = ? 23
Enter number 'c' in equation ax^2 + bxy + cy^2 = ? -20
Enter number ? in equation ax^2 + bxy + cy^2 = ? 14
Ok ax^2, gcd == 1
ax^2 GCD is 1 Ok, gcd = 1
cy^2 GCD is 2 Transform Req, gcd > 1, c < a
Transform Matrix [1,1],[-1,0]
-9 X^2 + -1 XY + 11 Y^2  =  1
Ok Unimodular Transform complete,( -9 , 14 )gcd == 1
>>> gcd_unimodular_Checker()
Enter number 'a' in equation ax^2 + bxy + cy^2 = ? 55
Enter number 'b' in equation ax^2 + bxy + cy^2 = ? 315
Enter number 'c' in equation ax^2 + bxy + cy^2 = ? 451
Enter number ? in equation ax^2 + bxy + cy^2 = ? -3971
ax^2 GCD is 11 Transform Req, gcd > 1
cy^2 GCD is 11 Unimodular Req, gcd > 1
Transform Matrix [1,-1],[1,0]
821 X^2 + -425 XY + 55 Y^2  =  451
Ok Unimodular Transform complete,( 821 , -3971 )gcd == 1
>>> 

## Alternative Euclid GCD ################## 
def Euclid_GCD(A, B):
    #Euclidean Algorithm for finding Extended GCD(A,B)#
    #Returns a triple (g, x, y), such that ax + by = g = gcd(a,b).#
    if A == 0:
        return (B, 0, 1)
    g, y, x = Euclid_GCD(B % A, A)#Division to find remainder.
    return (g, x - (B // A) * y, y) 
    

########GCD################################
from math import gcd  
def gcd(a,N):
    return gcd(N, a%N) if N > 0 else a;



        
    



